import xml_processor.xml_processor as xp
import database_connector.database_connector as db
import argparse
import atexit
import signal
import logging

MDM2NEO4J_VERSION: str = "0.1"

logging.basicConfig(level=logging.INFO)
logger = logging.getLogger(__name__)

logger.info("mdm2neo4j v{0}".format(MDM2NEO4J_VERSION))

# define parameters - pass xml files dir and db conf as arguments when running the script
parser = argparse.ArgumentParser()
parser.add_argument('-c', '--conf', required=True, type=str,
                    help='Configuration file with database connection parameters')
parser.add_argument('-f', '--files', required=True, type=str, help='Directory with xml files')

# parse parameters
args = parser.parse_args()
xml_file_path = args.files


# init db connection

# TODO

# define shutdown_hook

def shutdown_hook():
    # clise db connection
    neo4jconnection_object = db.Neo4jConnection()
    neo4jconnection_object.end_connection()
    logger.info("Connection to Neo4j database closed")
    exit()


def signal_handler(sig, frame):
    shutdown_hook()


atexit.register(shutdown_hook)
signal.signal(signal.SIGTERM, signal_handler)
signal.signal(signal.SIGHUP, signal_handler)
signal.signal(signal.SIGQUIT, signal_handler)
signal.signal(signal.SIGABRT, signal_handler)


# start mdm2neo4j

if __name__ == "__main__":
    xp.parse_xml(xml_file_path)
